/*
 * Copyright 2002 3plus4 software.
 * All Rights Reserved.
 */
package de.iiipiv.game;

/**
 * @version 	1.0
 * @author	sma@3plus4.de
 */
public class HexMapModel {
    static class Field {
        final Coord coord;
        int background;
        int object;
        boolean changed;
        Field(Coord coord) {
            this.coord = coord;
        }
    }
    private final Field[] fields;
    public final int w;
    public final int h;
    
    public HexMapModel(int w, int h) {
        this.w = w;
        this.h = h;
        fields = new Field[w * h];
        for (int i = 0; i < fields.length; i++) {
            fields[i] = new Field(new Coord(i % w, i / w));
        }
    }
    public Field getField(int x, int y) {
        return fields[index(x, y)];
    }
    public void setBackground(int x, int y, int bg) {
        Field f = getField(x, y);
        f.background = bg;
        f.changed = true;
    }
    public void setObject(int x, int y, int ob) {
        Field f = getField(x, y);
        f.object = ob;
        f.changed = true;
    }
    private final int index(int x, int y) {
        if (x >= w) throw new ArrayIndexOutOfBoundsException();
        return x + y * w;
    }
}
